#version 330

#include_part

struct LightSource
{ 
	vec3 color;
	vec3 position;

	float cAtt;
	float lAtt;
	float eAtt;
};

vec4 getLightColor(const LightSource light, vec3 vertexPosition, vec3 vertexNormal);

#definition_part

vec4 getLightColor(const LightSource light, vec3 vertexPosition, vec3 vertexNormal, vec3 ambient)
{
	vec3 vectorToLight = vertexPosition-light.position;
	float dist = length(vectorToLight);
	vectorToLight = normalize(vectorToLight);
	
	float diffuse = max(0.0, dot(vertexNormal, -vectorToLight));

	float attenuation = light.cAtt + light.lAtt*dist + light.eAtt*(dist*dist);

	return vec4(light.color, 1.0)*(ambient+diffuse)/attenuation;
}