#version 150


///Input: View-Matrix
uniform mat4 view;
///Input: Perspective-Matrix
uniform mat4 perspective;


///Vertex-Specific Input from the Client-Code
in vec4 in_Position;


///Vertex-Specific Output to the Fragment-Shader
out vec3 view_Dir;


void main()
{
    ///Position of the Camera
    vec4 worldViewPos = inverse(view)[3];
    ///World-Position of the Triangle-Vertex
    vec4 worldVertrexPos = inverse(perspective * view) * in_Position;
    ///Direction from the Camera to the Vertex
    view_Dir = normalize(worldViewPos.xyz / worldViewPos.w - worldVertrexPos.xyz / worldVertrexPos.w);


    gl_Position = in_Position;
}