/*---------------- "exampleFragmentShader.frag" ----------------*/
// QUELLE vom Grundgerst: http://en.wikipedia.org/wiki/Vertex_Buffer_Object
// 
 
#version 150 // Specify which version of GLSL we are using.
 
precision highp float; // Video card drivers require this line to function properly
 
uniform sampler2D myTextureSampler;

in vec2 UV;
in vec3 normal;
in vec3 lightDirection;
in vec3 eyeDirection;
in vec3 worldCoordinates;
in vec3 lightPosition_worldspace;

out vec3 color;


void main() 
{

	vec3 lightColor = vec3(1,1,1);
	vec3 materialSpecularColor = vec3(1,1,1);
	float distance =  length(  lightPosition_worldspace - worldCoordinates   );
	float lightPower = 1;

	vec3 n = normalize( normal );

	vec3 l = normalize( lightDirection );

	float cosTheta = clamp( dot( n,l ), 0,1 ); 

	vec3 E = normalize(eyeDirection);
	vec3 R = reflect(-l,n);
	float cosAlpha = clamp( dot( E,R ), 0,1 );




	vec3 materialDiffuseColor = texture( myTextureSampler, UV ).rgb;

	vec3 materialAmbientColor = vec3(0.3,0.3,0.3) * materialDiffuseColor;

	color = materialAmbientColor +
			 materialDiffuseColor * lightColor * lightPower * cosTheta / (distance*distance) +
			 materialSpecularColor * lightColor * lightPower * pow(cosAlpha,5) / (distance*distance);



}
/*--------------------------------------------------------------*/